# Table of contents

* [Introduction](README.md)
* [What does DCli do?](what-does-dcli-do.md)
* [Install DCli](getting-started/README.md)
  * [Installing on Windows](getting-started/installing-on-windows.md)
* [Writing your first CLI app](writing-your-first-script.md)
* [Add DCli to your project](added-dcli-to-your-project.md)
* [pub.dev](pub.dev.md)
* [github](github.md)

## Dart basics

* [Dart lambda functions](dart-basics/dart-lambda-functions.md)
* [Function Arguments](dart-basics/named-arguments.md)
* [Futures](dart-basics/futures.md)
* [stdin/stdout/stderr a primer](dart-basics/stdin-stdout-stderr.md)

## Tour <a href="dcli-api" id="dcli-api"></a>

* [Overview](dcli-api/overview.md)
* [Using DCli functions](dcli-api/using-dcli-functions.md)
* [User input](dcli-api/user-input/README.md)
  * [Ask Validators](dcli-api/user-input/ask-validators.md)
* [Displaying information](dcli-api/displaying-information.md)
* [Managing Files And Directories](dcli-api/managing-files-and-directories.md)
* [Environment variables](dcli-api/environment-variables.md)
* [Calling apps](dcli-api/calling-apps.md)
* [Command Line Arguments](dcli-api/command-line-arguments.md)
* [Paths](dcli-api/paths.md)
* [Glob Expansion](dcli-api/glob-expansion.md)
* [Piping](dcli-api/piping.md)
* [Locking](dcli-api/locking.md)
* [Fetch](dcli-api/fetch.md)
* [The evils of CD](dcli-api/the-evils-of-cd.md)
* [Assets/Resources](dcli-api/assets.md)
* [Cross Platform](dcli-api/cross-platform.md)

## Dependency Management <a href="dependency-management-1" id="dependency-management-1"></a>

* [Dependency Management](dependency-management-1/dependency-management.md)
* [Pubspec Managment](dependency-management-1/pubspec-managment.md)

## DCli Tools <a href="dcli-tools-1" id="dcli-tools-1"></a>

* [DCli tools](dcli-tools-1/dcli-tools.md)
* [Use a shebang #!](dcli-tools-1/use-a-shebang.md)
* [DCli Compile](dcli-tools-1/dcli-compile.md)
* [DCli Clean](dcli-tools-1/dcli-clean-1.md)
* [DCli Create](dcli-tools-1/dcli-create.md)
* [DCli Doctor](dcli-tools-1/dcli-doctor.md)
* [DCli Install](dcli-tools-1/dcli-install.md)
* [DCli run](dcli-tools-1/dcli-run.md)
* [DCli Warmup](dcli-tools-1/dcli-clean.md)
* [dcli pack](dcli-tools-1/dcli-pack.md)
* [Upgrade DCli](dcli-tools-1/upgrade-dcli.md)
* [Performance](dcli-tools-1/performance.md)
* [Docker](dcli-tools-1/docker.md)
  * [Ship a DCli app in Docker](dcli-tools-1/docker/ship-a-dcli-app-in-docker.md)
* [Elevated Privileges](dcli-tools-1/elevated-privileges/README.md)
  * [Sudo](dcli-tools-1/elevated-privileges/sudo.md)

## Internal Workings

* [Internal Workings](internal-workings/internal-workings.md)
* [waitForEx](internal-workings/waitforex.md)

***

* [Contributing](contributing/README.md)
  * [Creating a release](contributing/creating-a-release.md)
  * [Running Unit tests](contributing/running-unit-tests.md)
  * [Implemention support for a shell](contributing/implemention-support-for-a-shell.md)
* [References](references.md)

## Examples

* [Projects](examples/projects.md)
* [Code](examples/overview/README.md)
  * [hello world.](examples/overview/hello-world..md)
  * [dcompress](examples/overview/dcompress.md)
  * [dpath](examples/overview/dpath.md)
  * [dmysql](examples/overview/dmysql.md)
  * [dshell](examples/overview/dshell.md)
  * [dwhich](examples/overview/dwhich.md)
  * [dipaddr](examples/overview/dipaddr.md)
  * [gnome launcher](examples/overview/untitled.md)

## Articles

* [Video: package of the week](articles/package-of-the-week.md)
* [build CLI apps in dart - part 1](articles/build-console-apps-in-dart.md)
* [build CLI apps in dart - part 2](articles/build-cli-apps-in-dart-part-2.md)
* [Dealing with permissions](articles/dealing-with-permissions.md)

***

* [Dart on Linux - the perfect CLI tooling](dart-on-ubuntu-the-perfect-cli-dev-tooling.md)
